/*
 * Copyright 2012 The Ferris Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ferris.yahoo.finance.jmce.bean;

import java.util.Calendar;

/**
 *
 * @author mjr2958
 */
public class EmailAddress 
{
    public enum Type {
        cc, bcc, to, from, reply, admin
    }
        
    private String id;
    private Calendar createdOn;
    private Calendar updatedOn;
    private Type type;
    private String address;
    private String name;

    public EmailAddress(String id, Calendar createdOn, Calendar updatedOn, Type type, String address, String name) {
        this.id = id;
        this.createdOn = createdOn;
        this.updatedOn = updatedOn;
        this.type = type;
        this.address = address;
        this.name = name;
    }
    
    
    /**
     * @return the id
     */
    public String getId() {
        return id;
    }

    /**
     * @return the createdOn
     */
    public Calendar getCreatedOn() {
        return createdOn;
    }

    /**
     * @return the updatedOn
     */
    public Calendar getUpdatedOn() {
        return updatedOn;
    }

    /**
     * @return the type
     */
    public Type getType() {
        return type;
    }

    /**
     * @return the address
     */
    public String getAddress() {
        return address;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }


    
}
