/*
 * Copyright 2011 The Ferris Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ferris.yahoo.finance.jmce.bean;

import java.util.Calendar;
import java.util.Date;

/**
 *
 * @author Michael Remijan [mjremijan@yahoo.com]
 */
public class FuturesExpirations 
{
	private String id;
	private Calendar createdOn;
	private Calendar updatedOn;
	private String tickerSymbol;
	private String contractDescription;
	private char contractMonth;
	private int contractYear;
	private Date lastTradingDate;

	public FuturesExpirations(String id, Calendar createdOn, Calendar updatedOn, String tickerSymbol, String contractDescription, char contractMonth, int contractYear, Date lastTradingDate) {
		this.id = id;
		this.createdOn = createdOn;
		this.updatedOn = updatedOn;
		this.tickerSymbol = tickerSymbol;
		this.contractDescription = contractDescription;
		this.contractMonth = contractMonth;
		this.contractYear = contractYear;
		this.lastTradingDate = lastTradingDate;
	}

	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @return the createdOn
	 */
	public Calendar getCreatedOn() {
		return createdOn;
	}

	/**
	 * @return the updatedOn
	 */
	public Calendar getUpdatedOn() {
		return updatedOn;
	}

	/**
	 * @return the tickerSymbol
	 */
	public String getTickerSymbol() {
		return tickerSymbol;
	}

	/**
	 * @return the contractDescription
	 */
	public String getContractDescription() {
		return contractDescription;
	}

	/**
	 * @return the contractMonth
	 */
	public char getContractMonth() {
		return contractMonth;
	}

	/**
	 * @return the contractYear
	 */
	public int getContractYear() {
		return contractYear;
	}

	/**
	 * @return the lastTradingDate
	 */
	public Date getLastTradingDate() {
		return lastTradingDate;
	}
	
	
}
