/*
 * Copyright 2011 The Ferris Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ferris.yahoo.finance.jmce.bean;

import java.math.BigDecimal;
import java.util.Calendar;

/**
 *
 * @author Michael Remijan <mjremijan@yahoo.com>
 */
public class YearEndPrice 
{
	private String id;
	private String marketId;
	private int year;
	private BigDecimal price;
	private Calendar createdOn;
	private Calendar updatedOn;

	public YearEndPrice(String id, Calendar createdOn, Calendar updatedOn, String marketId, int year, BigDecimal price) {
		this.id = id;
		this.createdOn = createdOn;
		this.updatedOn = updatedOn;
		this.marketId = marketId;
		this.year = year;
		this.price = price;
	}
	
	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @return the year
	 */
	public int getYear() {
		return year;
	}

	/**
	 * @return the price
	 */
	public BigDecimal getPrice() {
		return price;
	}

	/**
	 * @return the createdOn
	 */
	public Calendar getCreatedOn() {
		return createdOn;
	}

	/**
	 * @return the updatedOn
	 */
	public Calendar getUpdatedOn() {
		return updatedOn;
	}

	/**
	 * @return the marketId
	 */
	public String getMarketId() {
		return marketId;
	}

	/**
	 * @param marketId the marketId to set
	 */
	public void setMarketId(String marketId) {
		this.marketId = marketId;
	}
}
