/*
 * Copyright 2011 The Ferris Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ferris.yahoo.finance.jmce.handler;

import org.apache.log4j.Logger;
import org.ferris.yahoo.finance.jmce.net.HtmlPageContents;

/**
 *
 * @author mjr2586
 */
public abstract class AbstractHandlerByScrape 
{
    private static final Logger log = Logger.getLogger(AbstractHandlerByScrape.class);
    
    public HtmlPageContents getHtmlPageContents(String url) {
        if (log.isInfoEnabled()) {
            log.info(String.format("ENTER getHtmlPageContents(%s)",url));
        }
        return new HtmlPageContents(url);
    }
	
	
	private YearEndPriceHandler yearEndPriceHandler;
	/**
	 * @return the yearEndPriceHandler
	 */
	public YearEndPriceHandler getYearEndPriceHandler() {
		return yearEndPriceHandler;
	}
	/**
	 * @param yearEndPriceHandler the yearEndPriceHandler to set
	 */
	public void setYearEndPriceHandler(YearEndPriceHandler yearEndPriceHandler) {
		this.yearEndPriceHandler = yearEndPriceHandler;
	}	
    
    public String getMarketDown(HtmlPageContents pageContents)
    {
        boolean up = pageContents.contains("up_g time_rtq_content");
        boolean down = pageContents.contains("down_r time_rtq_content");
        boolean neither = pageContents.contains("\" time_rtq_content\"");

        if (!up && !down && !neither) {
            throw new RuntimeException("Unable to determine if the market performance is up or down");
        }
        return (down) ? "-" : "";
    }
}
