/*
 * Copyright 2011 The Ferris Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ferris.yahoo.finance.jmce.handler;

import org.ferris.yahoo.finance.jmce.bean.Oil;

/**
 *
 * @author mjr2586
 */
public interface CrudeOilHandler 
{
	/**
	 * This handler needs to determine what is the current contract by 
	 * figuring how today's date falls within the the last trading (LT)
	 * days setup for the year for Oil.  This is determined by finding
	 * the first LT day which is >= to today.  That LT day will be associated
	 * with a month and it is that month which is currently under contract.
	 * Once the contract month is know, the future's ticker symbol can be
	 * determined by:
	 * 
	 * An email should be automatically set near the end of the year to lookup 
	 * the dates for next year so they can be inserted into the database.  This
	 * site may be good:
	 *
	 *  #1 http://alpari-forex.com/en/trader/futures_exp/
	 *	#2 http://www.ccstrade.com/futures/light--sweet-crude-oil-futures-cl/exp/
	 * 
	 * If Not, a Google search of "YYYY oil futures expiration" should help
	 * find the information
	 * 
	 * NOTE:	Last Trading Day (LT)
	 *			First Notice Day (FN)
	 */
    Oil getByCurrentContract();    
}
