/*
 * Copyright 2011 The Ferris Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ferris.yahoo.finance.jmce.lang;

import org.ferris.yahoo.finance.jmce.bean.YearEndPrice;

/**
 *
 * @author Michael Remijan [mjremijan@yahoo.com]
 */
public class StringBufferWrapper
	{
		private StringBuilder sp = new StringBuilder();
		public StringBufferWrapper appendLine(String s) {
			sp.append(s);
			sp.append("\n");
			return this;
		}
		public StringBufferWrapper appendLine(double d) {
			return appendLine(String.valueOf(d));
		}
		public StringBufferWrapper appendLine(int i) {
			return appendLine(String.valueOf(i));
		}
		public StringBufferWrapper appendLine(YearEndPrice yearEndPrice) {
			if (yearEndPrice != null) {
				return appendLine(yearEndPrice.getPrice().toString());
			} else {
				return appendLine("N/A");
			}
		}
		public String toString() {
			return sp.toString();
		}
		
	}