/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package junit.json;

import static org.junit.Assert.*;

import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.junit.Test;

/**
 *
 * @author mjr2958
 */
public class JSONTest {

    @Test
    public void test() throws Exception
    {    
//        System.setProperty("http.proxyHost", "localhost");
//        System.setProperty("http.proxyPort", "7777");        
//        
//        calendar
//            = Calendar.getInstance();
//        
//        String urlString =
//            String.format(
//            "http://www.cmegroup.com/CmeWS/md/MDServer/V1/Venue/G/Exchange/XCEC/FOI/FUT/Product/GC?currentTime=%d&contractCDs=,GCG2,GCH2,GCJ2,GCK2,GCM2,GCQ2,GCV2,GCZ2,GCG3,GCJ3,GCM3,GCQ3,GCV3,GCZ3,GCM4,GCZ4,GCM5,GCZ5,GCM6,GCZ6,GCM7,GCZ7,GCG2,GCH2,GCJ2,GCK2,GCM2,GCQ2,GCV2,GCZ2,GCG3,GCJ3,GCM3,GCQ3,GCV3,GCZ3,GCM4,GCZ4,GCM5,GCZ5,GCM6,GCZ6,GCM7,GCZ7"
//            , calendar.getTimeInMillis()
//        );
//        
//        System.out.println(urlString);
//        URL url = new URL(urlString);
//        URLConnection conn = url.openConnection();
//        InputStream is = conn.getInputStream();
//        LineNumberReader reader = new LineNumberReader(new InputStreamReader(is));        
//        for (String line = reader.readLine(); line != null; line = reader.readLine()) {
//            sp.append(line);
//            sp.append("\n");
//        }
//                
//        FileWriter writer = new FileWriter(f);
//        writer.write(sp.toString());
//        writer.flush();
//        writer.close();
        
        StringBuilder sp 
            = new StringBuilder();
        
        File f 
            = new File("C:\\Documents and Settings\\mjr2958\\Desktop\\c.html");
        
        InputStream in = getClass().getResourceAsStream("/json/c.json");
        InputStreamReader fr = new InputStreamReader(in);
        LineNumberReader reader = new LineNumberReader(fr);
        for (String line=reader.readLine(); line != null; line=reader.readLine()) {
            sp.append(line);
            sp.append("\n");
        }
        
        System.out.println(sp.toString());
        
        JSONParser parser=new JSONParser();
        
        JSONObject jsonObject 
            = (JSONObject)parser.parse(sp.toString());
        printKeys(jsonObject, "jsonObject");        

        
        JSONObject marketDataInfoAsStringList
            = (JSONObject)jsonObject.get("marketDataInfoAsStringList");
        printKeys(marketDataInfoAsStringList, "marketDataInfoAsStringList");
        
        JSONArray message
            = (JSONArray)marketDataInfoAsStringList.get("message");
        printSize(message, "message");
        
        int idx = 0;
        for (Object obj : message) {
            JSONObject jsonObj = (JSONObject) obj;
            printKeys(jsonObj, String.format("array[%d]",idx));
            idx++;        
        }
        
        printOpenInterest(message, "message");
        
        int greatestOpenInterest
            = getGreatestOpenInterest(message);
        System.out.printf("Greatest Open Interest: %d\n", greatestOpenInterest);
        assertEquals(251418, greatestOpenInterest);
        
        List<JSONObject> matching
            = getMatchingGreatestOpenInterest(message, greatestOpenInterest);
        System.out.printf("Matching Greatest Open Interest: %d\n", matching.size());
        assertEquals(2, matching.size());
        printValues(matching, "matching");
        
        System.out.println("\n[DONE]");
    }
    private static void printValues(List<JSONObject> matching, String name) 
    {
        System.out.println(name);
        int idx = 0;
        for (JSONObject jsonObj : matching)
        {
            System.out.printf("[%d]\n",idx++);
            for (Object k : jsonObj.keySet()) {                
                Object v = jsonObj.get(k);
                System.out.printf(" - \"%s\" : \"%s\"\n",k,v);
            }
        }
    }    
    private static List<JSONObject> getMatchingGreatestOpenInterest(JSONArray jsonArray, int greatestOpenInterest)
    {
        List<JSONObject> matches = new LinkedList<JSONObject>();
        for (Object obj : jsonArray) 
        {
            JSONObject jsonObj = (JSONObject) obj;
            String openInterest = (String)jsonObj.get("openInterest");
            if (!openInterest.equals("-")) {
                try {
                    int openInterestInt = Integer.parseInt(openInterest);
                    if (openInterestInt == greatestOpenInterest) {
                        matches.add(jsonObj);
                    }
                } catch (Throwable ignore) {}
            }                
        }
        
        return matches;
    }
    private static int getGreatestOpenInterest(JSONArray jsonArray)
    {
        int greatest = 0;
        for (Object obj : jsonArray) 
        {
            JSONObject jsonObj = (JSONObject) obj;
            String openInterest = (String)jsonObj.get("openInterest");
            if (!openInterest.equals("-")) {
                try {
                    int openInterestInt = Integer.parseInt(openInterest);
                    greatest = Math.max(greatest, openInterestInt);
                } catch (Throwable ignore) {}
            }                
        }
        
        return greatest;
    }
    private static void printOpenInterest(JSONArray jsonArray, String name)
    {
        System.out.println(name);
        Object[] array = jsonArray.toArray();
        for (int i=0; i<array.length; i++) {
            JSONObject arrayObj = (JSONObject)array[i];
            System.out.println(String.format(" [%2d] openInterest: \"%s\" ",i,arrayObj.get("openInterest")));
        }        
    }
    private static void printSize(JSONArray jsonArray, String name)
    {
        System.out.println(name);
        System.out.println(" - size: " + jsonArray.size());
    }
    private static void printKeys(JSONObject jsonObject, String name)
    {
        Set keySet = jsonObject.keySet();
        System.out.println(name);
        for (Object o : keySet) {
            System.out.println(" - key: " + o);
        }
    }

            
}
